latentystar <- function(y, xi, X, Z, betasubj, betasite, theta, sigma, a) 
{
#sorting first by tooth then by subject
low = a[y+1]
upp = a[y+2]
n = nrow(y)
m = ncol(y)
meansubj = as.double(as.matrix(X) %*% betasubj) # length 288 
meansite = as.double(as.matrix(Z) %*% betasite) # length 168
mean = as.double(t(matrix(meansite, ncol=n, nrow=m)) + matrix(meansubj, ncol=m, nrow=n)) + theta[xi]
res <- matrix(truncnorm(1, low, upp, mean, sigma[xi]), n,m)
res
}

labelling3_c <- function(ytilde, slices, w, theta, sigma) 
{
	n = nrow(ytilde)
	m = ncol(ytilde)
	k = length(theta)
 	xi <- .C("labelling3", xi=as.integer(rep(0,n*m)), as.double(t(ytilde)), as.double(t(slices)), as.double(w), as.double(theta), as.double(sigma), as.integer(c(n,m,k)))$xi
	t(matrix(xi,m,n))
}

psb.weights <- function(x){
	k <- length(x)
	Phi <- pnorm(x)
	ImPhi <- 1 - Phi
	Phi * c(1, cumprod(ImPhi)[-k])
}